(* SYNTACTIC DOMAINS *)

    type ide = string 
    type exp = 
      | Eint of int 
      | Ebool of bool 
      | Den of ide
      | Prod of exp * exp
      | Sum of exp * exp
      | Diff of exp * exp
      | Eq of exp * exp
      | Minus of exp
      | Iszero of exp
      | Or of exp * exp
      | And of exp * exp
      | Not of exp
      | Ifthenelse of exp * exp * exp
      | Val of exp
      | Let of ide * exp * exp	  
      | Newloc of exp	  
      | Fun of ide list * exp
      | Rec of ide * exp
      | Appl of exp * exp list
      | Proc of ide list * block
      (* object-oriented fragment *)
      | Field of exp * ide
      | New of ide * exp list
      | This
	  
    and decl = (ide * exp) list * (ide * exp) list
    and block = (ide * exp) list * (ide * exp) list  * com list
	
    and com = 
       | Assign of exp * exp
       | Cifthenelse of exp * com list * com list
       | While of exp * com list	   
       | Block of block
       | Call of exp * exp list
	   
       
(* class declaration: name, parameters, superclass and parameters, 
	      fields and initialization *)
      
    type cdecl = Class of ide * ide list * (ide * ide list) * block
    type prog = cdecl list * block
       
   
