
let pushmarkstack (i: pointer) =
    if lungh(markstack) = markstacksize 
      then failwith("markstack length has to be increased")
      else push(i, markstack)

    
let disallocate (i:pointer) =
    let pre = !next in
    next := i;
    Array.set nexts i pre

let collect = function () ->
         let i = ref(0) in
         while !i < heapsize do
           (if Array.get marks !i then (Array.set marks !i false)  
	   else disallocate(!i));
	   i := !i +1
         done

let markobject (i: pointer) =
   if Array.get marks i then ()
   else 
    (Array.set marks i true;
    let ob = Array.get objects i in
    let den = getden(ob) in
    let st = getst(ob) in
    let index = ref(0) in
    while !index < Array.length den do
      (match Array.get den !index with
        | Dobject j -> pushmarkstack(j)
	| _ -> ());
      index := !index + 1
    done;
    index := 0;
    while !index < Array.length st do
      (match Array.get st !index with
        | Mobject j -> pushmarkstack(j)
	| _ -> ());
      index := !index + 1
    done)
    
let startingpoints() =
   let index1 = ref(0) in
   let index2 = ref(0) in
   (* dvalstack *)
   while !index1 <= lungh(dvalstack) do
     let adval = access(dvalstack, !index1) in
     index2 := 0;
     while !index2 < Array.length adval do
       (match Array.get adval !index2 with
        | Dobject j -> pushmarkstack(j)
	| _ -> ());
      index2 := !index2 + 1
     done;
     index1 := !index1 + 1
   done;
   index1 := 0;
   (* storestack *)
   while !index1 <= lungh(storestack) do
     let adval = access(storestack, !index1) in
     index2 := 0;
     while !index2 < Array.length adval do
       (match Array.get adval !index2 with
        | Mobject j -> pushmarkstack(j)
	| _ -> ());
      index2 := !index2 + 1
     done;
     index1 := !index1 + 1
   done;
   (* tempvalstack *)
   index1 := 0;
   while !index1 <= lungh(tempvalstack) do
     let tempstack = access(tempvalstack, !index1) in
     index2 := 0;
      while !index2 <= lungh(tempstack) do
         (match access(tempstack,!index2) with
	   | Object j -> pushmarkstack(j)
	   | _ -> ());
	 index2 := !index2 + 1
      done;
      index1 := !index1 + 1
    done;
    (* tempdvalstack *)
   index1 := 0;
   while !index1 <= lungh(tempdvalstack) do
     let tempstack = access(tempdvalstack, !index1) in
     index2 := 0;
      while !index2 <= lungh(tempstack) do
         (match access(tempstack,!index2) with
	   | Dobject j -> pushmarkstack(j)
	   | _ -> ());
	 index2 := !index2 + 1
      done;
      index1 := !index1 + 1
    done
     
let mark() = 
   startingpoints();
   while not(empty(markstack)) do
     let current = top(markstack) in
     pop(markstack);
     markobject(current)
   done
    
    
	 
    (* questa va per ultima *)
let newpoint() = if not(!next = -1) then (!next)
   else 
     (mark(); collect(); 
     if !next = -1 then failwith("the heap size is not sufficient")
     else !next)

