
(*SEMANTIC EVALUATION FUNCTIONS  *)

let newframes(e,rho) =
   let cframe = emptystack(cframesize(e),Expr1(e)) in
   let tframe = emptystack(tframesize(e),Unbound) in
   push(Expr1(e),cframe);
   push(cframe,cstack);
   push(tframe,tempvalstack);
   pushenv(rho)
				
let sem ((e:exp), (r:eval env)) =
  push(emptystack(1,Unbound),tempvalstack);
  newframes(e,r);    
  while not(empty(cstack)) do
    while not(empty(top(cstack))) do  
     let continuation = top(cstack) in
     let tempstack = top(tempvalstack) in
     let rho = topenv() in 
     (match top(continuation) with
	  |Expr1(x) -> 
         (pop(continuation);
         push(Expr2(x),continuation); 
         (match x with
      
          | Iszero(a) -> push(Expr1(a),continuation)
          | Eq(a,b) -> push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
	      | Prod(a,b) ->  push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
          | Sum(a,b) -> push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
          | Diff(a,b)  ->  push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
          | Minus(a) ->  push(Expr1(a),continuation)
          | And(a,b) ->  push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
          | Or(a,b) ->  push(Expr1(a),continuation); 
                push(Expr1(b),continuation)
          | Not(a) -> push(Expr1(a),continuation)
		  | Ifthenelse(a,b,c) -> push(Expr1(a),continuation)
		  | Let(i,e1,e2) -> push(Expr1(e1),continuation)
		  | _ -> ()))
	 |Expr2(x) -> 
         (pop(continuation);
         (match x with
          | Eint(n) ->  push(Int(n),tempstack)
          | Ebool(b) -> push(Bool(b),tempstack)
          | Den(i) ->   push(applyenv(rho,i),tempstack)
		  | Iszero(a) -> 
             let arg=top(tempstack) in
             pop(tempstack);
             push(iszero(arg),tempstack)
          | Eq(a,b) -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(equ(firstarg,sndarg),tempstack)
		  | Prod(a,b) -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(mult(firstarg,sndarg),tempstack)  
          | Sum(a,b) -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(plus(firstarg,sndarg),tempstack)
          | Diff(a,b)  -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(diff(firstarg,sndarg),tempstack) 
          | Minus(a) -> 
             let arg=top(tempstack) in
             pop(tempstack);
             push(minus(arg),tempstack)  
          | And(a,b) -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(et(firstarg,sndarg),tempstack)  
          | Or(a,b) -> 
             let firstarg=top(tempstack) in
             pop(tempstack);
             let sndarg=top(tempstack) in
             pop(tempstack);
             push(vel(firstarg,sndarg),tempstack)  
          | Not(a) -> 
             let arg=top(tempstack) in
             pop(tempstack);
             push(non(arg),tempstack) 
          | Ifthenelse(a,b,c) ->
             let arg=top(tempstack) in
             pop(tempstack);
             if typecheck("bool",arg) then
               (if arg = Bool(true) 
               then push(Expr1(b),continuation)
               else push(Expr1(c),continuation))
            else failwith ("type error")
		  | Let(i,e1,e2) -> let arg=top(tempstack) in
             pop(tempstack); newframes(e2,bind(rho, i, arg)))))
      done;
      let valore= top(top(tempvalstack)) in
	  pop(top(tempvalstack));
      popenv();
      pop(cstack);
      pop(tempvalstack);
      push(valore,top(tempvalstack));
    done;
    let valore = top(top(tempvalstack)) in
	pop(top(tempvalstack));
	pop(tempvalstack); valore
	  


