(* SYNTACTIC DOMAINS *)

  (* Expressions *)

    type ide = string 
    type exp = 
      | Eint of int 
      | Ebool of bool 
      | Den of ide
      | Prod of exp * exp
      | Sum of exp * exp
      | Diff of exp * exp
      | Eq of exp * exp
      | Minus of exp
      | Iszero of exp
      | Or of exp * exp
      | And of exp * exp
      | Not of exp
      | Ifthenelse of exp * exp * exp
	  
(* new for the imperative fragment *)

      | Val of exp
      
(* Commands *)

    and com = 
           | Assign of exp * exp
	   | Cifthenelse of exp * com list * com list
	   | While of exp * com list
	   
   
